#include<stdio.h>
#include<stdlib.h>
#include<netinet/in.h>	//struct sockaddr_in
#include<sys/socket.h>	//socket(), bind()...
#include<sys/types.h>	//socket(), bind()...
#include<string.h>	//strlen()
#include<strings.h>	//bzero()

#define BUFFER 4096
#define MAX_QUEUE_SIZE 10
#define SERVER_PORT 5000

char * getLoadAvg();
int Socket(int domain, int type, int protocol);
void Bind(int  sockfd,  const  struct  sockaddr *my_addr, socklen_t addrlen);
void Listen(int sockfd, int backlog);

/** It is main function, which accepts connection from load_balancer, and
  * sends Load Average parameters of the system.
  *
  */
int main()
{
	char * loadStr;
	int listen_file_descriptor;
	int connection_file_descriptor;
	struct sockaddr_in client_addr;
	struct sockaddr_in server_address;
	int clientlength = sizeof(client_addr);
	int optval = 1;     //used to handle bind error
	listen_file_descriptor = Socket(AF_INET, SOCK_STREAM, 0);
    	setsockopt(listen_file_descriptor, SOL_SOCKET, SO_REUSEADDR, (void *)&optval, sizeof(optval));      //used to handle bind error TIME-WAIT

    	bzero(&server_address, sizeof(server_address));
    	server_address.sin_family = AF_INET;
    	server_address.sin_addr.s_addr  = htonl(INADDR_ANY);
    	server_address.sin_port = htons(SERVER_PORT);
    	Bind(listen_file_descriptor, (struct sockaddr *) &server_address, sizeof(server_address));
    	Listen(listen_file_descriptor, MAX_QUEUE_SIZE);
	//Accept connection, call getLoadAvg() and write loadAvg string to the socket.
	while(1)
	{
		connection_file_descriptor = accept(listen_file_descriptor, (struct sockaddr *) &client_addr, &clientlength);
		if(connection_file_descriptor < 0)
                {
                    perror("accept() failed.");
                    //exit(EXIT_FAILURE);
                }
		loadStr = getLoadAvg();
		printf("%s" ,loadStr);
		write(connection_file_descriptor, loadStr, strlen(loadStr));
		close(connection_file_descriptor);
	}
	return 0;
}

/** This function is called by main(). It executes command uptime in the
  * system, and returns only Laod average parameters to the calling function.
  *
  */
char * getLoadAvg()
{
	static char loadAvg[BUFFER];
	int i;
	char command[BUFFER];
	FILE *fp;
	loadAvg[0] = '\0';
	for(i=5;i>0;i--)
	{
		sprintf(command,"uptime | cut -d ':' -f %d > loadTemp.txt", i);
		system(command);
		fp = fopen("loadTemp.txt","r");
		if(fp==NULL)return NULL;
		fgets(loadAvg, BUFFER, fp);
		fclose(fp);
		if(strlen(loadAvg)>5)
			break;
	}
	system("rm -f laodTemp.txt");
	return loadAvg;
}

int Socket(int domain, int type, int protocol)
{
    int return_value;
    return_value = socket(domain, type, protocol);
    if(return_value < 0)
    {
        fprintf(stderr, "Cannot open socket.\n");
        perror("REASON");
        exit(1);
    }
    return return_value;
}

void Bind(int  sockfd,  const  struct  sockaddr *my_addr, socklen_t addrlen)
{
    int return_value;
    return_value= bind(sockfd,my_addr,addrlen);
    if(return_value < 0)
    {
        perror("Cannot bind");
        exit(1);
    }
}

void Listen(int sockfd, int backlog)
{
    int return_value;
    return_value = listen(sockfd, backlog);
    if(return_value < 0)
    {
        perror("Cannot listen");
        exit(1);
    }
}

